/*
 * JLex specification of the Expressive scanner
 *
 * $Id: expressive.lex,v 1.5 2003/03/18 14:40:58 stenman Exp $
 */

package expressive;

import java_cup.runtime.Symbol;

%%
%cup
%class Scanner
%implements Tokens, java_cup.runtime.Scanner
%type Symbol

%char
%line

%eofval{
  return mkToken(EOF);
%eofval}

%{

private int pos() {
  return Position.encode(yyline + 1, yychar);
}

private Symbol mkToken(int k) {
    return mkToken(k, null); 
}

private Symbol mkToken(int k, Object value) {
    return new Symbol(k, yychar, pos(), value);
}

%}

letter=[a-zA-Z_]
digit=[0-9]
whitespace=[\t ]

%%

\n { yychar = 0; /* Start a new line */}

{whitespace}    {/* Skip whitespace */}

":=" { return mkToken(ASSIGN); }

"true" { return mkToken(TRUE); }

{digit}+ { return mkToken(INT, new Integer(yytext())); }

. { Global.instance.error(pos(), "Illegal character: " + yytext()); }
